#!/bin/sh
# Script for OVT startup
# $Id: ovt.sh,v 1.7 2000/06/14 12:47:09 yuri Exp $
# $Source: /net/nest/stor/devel/ovt2g/bin/ovt.sh,v $   
#

echo "Orbit Visualization Tool"
echo "(c) Copyright OVT Team 2000"

JAVA_HOME_DEFAULT=/usr/local/jdk1.1.8;	export JAVA_HOME_DEFAULT
USER_HOME_DEFAULT=$HOME/ovt2g;		export USER_HOME_DEFAULT
OVT_HOME_DEFAULT=/usr/local/ovt2g;	export OVT_HOME_DEFAULT

#VTK_CLASSPATH=/opt/devel;		export VTK_CLASSPATH
#VTK_LIBS=/usr/local/lib;		export VTK_LIBS

if [ "$VTK_CLASSPATH" != "" ]
then
	echo Adding $VTK_CLASSPATH to CLASSPATH
	CLASSPATH=$CLASSPATH:$VTK_CLASSPATH;	export CLASSPATH
fi
if [ "$VTK_LIBS" != "" ]
then
        echo Adding $VTK_LIBS to LD_LIBRARY_PATH
        LD_LIBRARY_PATH=$VTK_LIBS:$LD_LIBRARY_PATH;    export LD_LIBRARY_PATH
fi

#OVT_HOME
if [ "$OVT_HOME" = "" ]
then
        OVT_HOME=$OVT_HOME_DEFAULT;           export OVT_HOME
fi

if test -z $OVT_HOME
then
	OVT_HOME=$HOME/ovt2g;		export OVT_HOME
fi

if test -x $OVT_HOME/bin/ovt.sh
then
	echo "OVT_HOME  = "$OVT_HOME
else
	echo "OVT_HOME is not set properly"
	echo "check OVT_HOME variable or edit " $OVT_HOME "/bin/ovt.sh"
	echo "exiting ..."
	exit 1
fi

#JAVA_HOME
if [ "$JAVA_HOME" = "" ]
then 
	JAVA_HOME=$JAVA_HOME_DEFAULT;		export JAVA_HOME
fi

if test -x $JAVA_HOME/bin/java
then
	echo "JAVA_HOME = "$JAVA_HOME
else
	echo "java is not found in " $JAVA_HOME/bin
	echo "check JAVA_HOME variable or edit " $OVT_HOME "/bin/ovt.sh"
	echo "exiting ..."
	exit 1
fi

LD_LIBRARY_PATH=$OVT_HOME/bin:$LD_LIBRARY_PATH;	export LD_LIBRARY_PATH
CLASSPATH=$CLASSPATH:$OVT_HOME/ovt.jar;	export CLASSPATH

if [ "$1" = "-test" ]
then
	echo "Testing VTK."
	echo "Showing VTK window..."
	$JAVA_HOME/bin/java ovt.test
elif [ "$1" = "-install" ] 
then
	echo "Creating OVT user directory..."
	if test -d $USER_HOME_DEFAULT 
	then
		echo "OVT user directory '"$USER_HOME_DEFAULT"' already exist."
		exit 1		
	else
		mkdir $USER_HOME_DEFAULT
		cp -R $OVT_HOME/conf $USER_HOME_DEFAULT
		cp -R $OVT_HOME/userdata $USER_HOME_DEFAULT
		echo "Done."
	fi


elif [ "$1" = "" ]
then
	echo "Starting OVT2 ..."
	if test -d $HOME/ovt2g 
	then
		USER_HOME=$USER_HOME_DEFAULT;	export USER_HOME
	else
		USER_HOME=$OVT_HOME;		export USER_HOME
	fi
	echo "USER_HOME = "$USER_HOME
	$JAVA_HOME/bin/java -Dovt.home=$OVT_HOME -Dovt.user=$USER_HOME ovt.XYZWindow

else
	echo "\nUsage:"
	echo "-test      test VTK (Visualization Toolkit)"
	echo "-install   create OVT user directory"
fi

