/*=========================================================================

  Program:   Orbit Visualization Tool
  Source:    $Source: /net/nest/stor/devel/ovt2g/ovt/PolarWindow.java,v $
  Date:      $Date: 2000/04/11 15:41:33 $
  Version:   $Revision: 1.5 $


Copyright (c) 2000 OVT Team (Kristof Stasiewicz, Mykola Khotyaintsev, 
Yuri Khotyaintsev)
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification is permitted provided that the following conditions are met:

 * No part of the software can be included in any commercial package without
written consent from the OVT team.

 * Redistributions of the source or binary code must retain the above
copyright notice, this list of conditions and the following disclaimer.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT OR
INDIRECT DAMAGES  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE.

OVT Team (http://ovt.irfu.se)   K. Stasiewicz, M. Khotyaintsev, Y.
Khotyaintsev

=========================================================================*/

/*
 * ArtWindow.java
 *
 * Created on March 21, 2000, 5:49 PM
 */
 
package ovt;

import ovt.*;
import ovt.gui.*;
import ovt.util.*;
import ovt.event.*;
import ovt.object.*;
import ovt.datatype.*;
import ovt.interfaces.*;

import vtk.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.IOException;

import javax.swing.*;
import javax.swing.filechooser.*;
import javax.swing.event.*;

/** 
 *
 * @author  root
 * @version 
 */
public class PolarWindow extends JFrame implements Renderable {

  
  protected OVTCore core;
	// Panels
  public vtkPanel renPanel;
  public TreePanel treePanel;
  public JMenuBar coreMenuBar;

  public JSplitPane splitPane;
	
  public vtkRenderer ren;
	//public CameraToolBar cameraToolBar;
	
	// Toolbars
  public PolarToolBar toolBar;

        //public CoreMenuBar coreMenuBar;
  public vtkActor earthActor;

    /** Creates new ArtWindow */
  public PolarWindow() {
    super("Polar Window");
    //setDefaultCloseOperation(WindowConstants.HIDE_ON_CLOSE);
    

//------- create the vtkPanel ----------

    addNotify();
    renPanel = new vtkPanel();
    renPanel.setSize(400, 400);
    // set the renderer
    ren = renPanel.getRenderer();        

//------- set up the menu -------------
/*  
    JPopupMenu.setDefaultLightWeightPopupEnabled(false);

    coreMenuBar = new JMenuBar();
    setJMenuBar(coreMenuBar);
*/
    Container contentPane = getContentPane();
    contentPane.setLayout(new BorderLayout());
    contentPane.add(renPanel, BorderLayout.CENTER);
  }

  public void start() {
    // add main ToolBar
    toolBar = new PolarToolBar(getCore(), this);
    getContentPane().add(toolBar, BorderLayout.SOUTH);

    // add main ToolBar
/*    toolBar = new XYZToolBar(getCore(), this);
    contentPane.add(toolBar, BorderLayout.SOUTH);*/
	
    //showEarth();
    ren.SetBackground(0.9, 0.9, 0.9); 	

    
    //refreshGUI();
    pack();
    
    Dimension scrnSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension windowSize = getSize();
    /*setLocation(scrnSize.width/2 - windowSize.width/2, 
                 (scrnSize.height/2 - windowSize.height/2));*/
    setLocation(750, (scrnSize.height/2 - windowSize.height/2));
  }

  public OVTCore getCore() { 
    return core; 
  }

  public void setCore(OVTCore core) { 
    this.core = core; 
  }
  
  public void Render() 
	{ renPanel.Render(); }

  public vtkRenderer getRenderer()
	{ return renPanel.getRenderer(); }

  public vtkRenderWindow getRenderWindow() {
    return renPanel.getRenderWindow();
  }

  public void showEarth() {
    vtkAxes axes = new vtkAxes();
    axes.SetScaleFactor(2);
    
    
    vtkPolyDataMapper mapper = new vtkPolyDataMapper();
    mapper.SetInput(axes.GetOutput());
    
    vtkActor actor = new vtkActor();
    actor.SetMapper(mapper);
    
    getRenderer().AddActor(actor);
  }
}