/*=========================================================================

  Program:   Orbit Visualization Tool
  Source:    $Source: /net/nest/stor/devel/ovt2g/ovt/event/TimeEvent.java,v $
  Date:      $Date: 2000/04/11 15:42:03 $
  Version:   $Revision: 1.2 $


Copyright (c) 2000 OVT Team (Kristof Stasiewicz, Mykola Khotyaintsev, 
Yuri Khotyaintsev)
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification is permitted provided that the following conditions are met:

 * No part of the software can be included in any commercial package without
written consent from the OVT team.

 * Redistributions of the source or binary code must retain the above
copyright notice, this list of conditions and the following disclaimer.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT OR
INDIRECT DAMAGES  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE.

OVT Team (http://ovt.irfu.se)   K. Stasiewicz, M. Khotyaintsev, Y.
Khotyaintsev

=========================================================================*/

/*
 * TimeEvent.java
 *
 * Created on March 8, 2000, 1:39 PM
 */
 
package ovt.event;

import ovt.datatype.*;

import java.beans.*;
import java.util.*;
/** 
 *
 * @author  root
 * @version 
 */
public class TimeEvent extends PropertyChangeEvent {
  
  
  /** Holds value of property timeMap. */
  private Vector timeMap;
  
  /** Creates new TimeEvent */
  public TimeEvent(Object source, String propertyName, Object oldValue, Object newValue, Vector timeMap) {
    super(source, propertyName, oldValue, newValue);
    setTimeMap(timeMap);
  }
  
  /** Getter for property timeMap.
   * @return Value of property timeMap.
   */
  public Vector getTimeMap() {
    return timeMap;
  }
  /** Setter for property timeMap.
   * @param timeMap New value of property timeMap.
   */
  public void setTimeMap(Vector timeMap) {
    this.timeMap = timeMap;
  }
  
  public TimeSet getNewTimeSet() 
    { return (TimeSet)getNewValue(); }
}