/*=========================================================================

  Program:   Orbit Visualization Tool
  Source:    $Source: /net/nest/stor/devel/ovt2g/ovt/gui/DumperDialog.java,v $
  Date:      $Date: 2000/06/13 22:02:01 $
  Version:   $Revision: 1.6 $


Copyright (c) 2000 OVT Team (Kristof Stasiewicz, Mykola Khotyaintsev, 
Yuri Khotyaintsev)
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification is permitted provided that the following conditions are met:

 * No part of the software can be included in any commercial package without
written consent from the OVT team.

 * Redistributions of the source or binary code must retain the above
copyright notice, this list of conditions and the following disclaimer.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT OR
INDIRECT DAMAGES  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE.

OVT Team (http://ovt.irfu.se)   K. Stasiewicz, M. Khotyaintsev, Y.
Khotyaintsev

=========================================================================*/

/*
 * DumperDialog.java
 *
 * Created on den 12 juni 2000, 19:37
 */
 
package ovt.gui;

import java.io.*;
import javax.swing.*;

import ovt.object.Sat;

/** 
 *
 * @author  Yuri Khotyaintsev
 * @version 1.0
 */
public class DumperDialog extends javax.swing.JDialog {

  protected java.io.File outFile = null;
  public java.awt.Frame parent =null;
  private ManualDumper manualDialog = null;
  protected Sat sat = null;
  /** Creates new form Dumper */
  public DumperDialog(java.awt.Frame parent,boolean modal,ovt.object.Sat sat) {
    super (parent, modal);
    this.parent = parent;
    this.sat = sat;
    initComponents ();
    pack ();
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents () {//GEN-BEGIN:initComponents
    mainPanel = new javax.swing.JPanel ();
    filePanel = new javax.swing.JPanel ();
    fileLabel = new javax.swing.JLabel ();
    filenameTextField = new javax.swing.JTextField ();
    browseBtn = new javax.swing.JButton ();
    optionsPanel = new javax.swing.JPanel ();
    posChBox = new javax.swing.JCheckBox ();
    footprintChBox = new javax.swing.JCheckBox ();
    mpChBox = new javax.swing.JCheckBox ();
    spinChBox = new javax.swing.JCheckBox ();
    buttonsPanel = new javax.swing.JPanel ();
    okBtn = new javax.swing.JButton ();
    cancelBtn = new javax.swing.JButton ();
    modePanel = new javax.swing.JPanel ();
    modeLbl = new javax.swing.JLabel ();
    autoRBtn = new javax.swing.JRadioButton ();
    manualRBtn = new javax.swing.JRadioButton ();
    setTitle ("Dumping");
    setName ("dumperDialog");
    addWindowListener (new java.awt.event.WindowAdapter () {
      public void windowClosing (java.awt.event.WindowEvent evt) {
        closeDialog (evt);
      }
    }
    );

    mainPanel.setLayout (new java.awt.BorderLayout ());

      filePanel.setLayout (new java.awt.GridLayout (1, 3));
      filePanel.setBorder (new javax.swing.border.TitledBorder("File"));
  
        fileLabel.setText ("Filename");
    
        filePanel.add (fileLabel);
    
        filenameTextField.setEditable (false);
    
        filePanel.add (filenameTextField);
    
        browseBtn.setText ("Change...");
        browseBtn.addActionListener (new java.awt.event.ActionListener () {
          public void actionPerformed (java.awt.event.ActionEvent evt) {
            browseBtnPressed (evt);
          }
        }
        );
    
        filePanel.add (browseBtn);
    
      mainPanel.add (filePanel, java.awt.BorderLayout.SOUTH);
  
      optionsPanel.setLayout (new java.awt.GridLayout (4, 1));
      optionsPanel.setBorder (new javax.swing.border.TitledBorder("Options to save"));
  
        posChBox.setSelected (true);
        posChBox.setText ("Position");
    
        optionsPanel.add (posChBox);
    
        footprintChBox.setSelected (true);
        footprintChBox.setText ("Footprints");
    
        optionsPanel.add (footprintChBox);
    
        mpChBox.setText ("Distance to magnetopause");
    
        optionsPanel.add (mpChBox);
    
        spinChBox.setText ("Spin");
    
        optionsPanel.add (spinChBox);
    
      mainPanel.add (optionsPanel, java.awt.BorderLayout.CENTER);
  

    getContentPane ().add (mainPanel, java.awt.BorderLayout.CENTER);

    buttonsPanel.setLayout (new java.awt.GridLayout (1, 2));

      okBtn.setText ("OK");
      okBtn.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          okBtnPressed (evt);
        }
      }
      );
  
      buttonsPanel.add (okBtn);
  
      cancelBtn.setText ("Cancel");
      cancelBtn.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          cancelBtnPressed (evt);
        }
      }
      );
  
      buttonsPanel.add (cancelBtn);
  

    getContentPane ().add (buttonsPanel, java.awt.BorderLayout.SOUTH);

    modePanel.setLayout (new java.awt.GridLayout (1, 3));
    modePanel.setBorder (new javax.swing.border.TitledBorder("Mode"));

      modeLbl.setText ("Logging");
  
      modePanel.add (modeLbl);
  
      autoRBtn.setText ("cartoon");
      javax.swing.ButtonGroup modeGrp = new javax.swing.ButtonGroup();
      modeGrp.add(autoRBtn);
  
      modePanel.add (autoRBtn);
  
      manualRBtn.setSelected (true);
      manualRBtn.setText ("manual");
      modeGrp.add(manualRBtn);
  
      modePanel.add (manualRBtn);
  

    getContentPane ().add (modePanel, java.awt.BorderLayout.NORTH);

  }//GEN-END:initComponents

  private void cancelBtnPressed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelBtnPressed
    sat.setDumperVisible(false);
  }//GEN-LAST:event_cancelBtnPressed

  private void okBtnPressed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okBtnPressed
    if ( outFile == null ) {
      JOptionPane.showMessageDialog(parent,
                             "Please specify the file to write.",
                             "File not set",
                             JOptionPane.INFORMATION_MESSAGE);
      return;
    }
    enableEditing(false);
    if (!sat.isVisible())sat.setVisible(true);
    if ( autoRBtn.isSelected() ) {
      //do auto
      sat.setupDumper(outFile.getAbsolutePath(),posChBox.isSelected(),footprintChBox.isSelected(),
            mpChBox.isSelected(),spinChBox.isSelected(),false);
      double startMjd = sat.getCore().getTimeSettings().getStartMjd();
      double stopMjd = sat.getCore().getTimeSettings().getStopMjd();
      double stepMjd = sat.getCore().getTimeSettings().getStepMjd();
      for(double tt=startMjd;tt<stopMjd;tt+=stepMjd){
        try {
          sat.getCore().getTimeSettings().setCurrentMjd(tt);
          sat.writeDumpRecord();
        } catch (java.beans.PropertyVetoException e){
          System.out.println(e.toString());
        }
      }
      sat.dumperClose();
      enableEditing(true);
    }else{
      //do manual
      //System.out.println("Dumper setup...");
      sat.setupDumper(outFile.getAbsolutePath(),posChBox.isSelected(),footprintChBox.isSelected(),
            mpChBox.isSelected(),spinChBox.isSelected(),false);
      manualDialog = new ManualDumper(parent,false,this);
      manualDialog.setLocation(this.getLocation());
      //System.out.println("Dumper close...");
      //sat.dumperClose();
      this.setVisible(false);
      manualDialog.setVisible(true);
    }
  }//GEN-LAST:event_okBtnPressed

  private void browseBtnPressed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_browseBtnPressed
    JFileChooser chooser = null;
    if ( outFile == null ) {
      chooser = new JFileChooser(ovt.OVTCore.getUserdataDir());
    }
    else {
      chooser = new JFileChooser(outFile);
    }
    int returnVal = chooser.showOpenDialog(parent);
    if (returnVal == JFileChooser.APPROVE_OPTION) {
      File tmpFile = chooser.getSelectedFile();
      if ( tmpFile.exists() ) {
        int res = JOptionPane.showConfirmDialog(parent,
             "File alredy exists. Overwrite?",
             "Overwrite ?",
             JOptionPane.YES_NO_OPTION);
        if ( res == 2) return;
        if ( tmpFile.isDirectory() ) {
          JOptionPane.showMessageDialog(parent,
                             "File is a directory.",
                             "File error",
                             JOptionPane.ERROR_MESSAGE);
          return;
        }
        if ( tmpFile.canWrite() ) {
          outFile = tmpFile;
          filenameTextField.setText(outFile.toString());
        }
        else{
          JOptionPane.showMessageDialog(parent,
                               "File is not writable.",
                               "File error",
                               JOptionPane.ERROR_MESSAGE);
          return;
        }
      }
      outFile = tmpFile;
      filenameTextField.setText(outFile.toString());
    }
  }//GEN-LAST:event_browseBtnPressed

  /** Closes the dialog */
  private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
    setVisible (false);
    dispose ();
  }//GEN-LAST:event_closeDialog



  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JPanel mainPanel;
  private javax.swing.JPanel filePanel;
  private javax.swing.JLabel fileLabel;
  private javax.swing.JTextField filenameTextField;
  private javax.swing.JButton browseBtn;
  private javax.swing.JPanel optionsPanel;
  private javax.swing.JCheckBox posChBox;
  private javax.swing.JCheckBox footprintChBox;
  private javax.swing.JCheckBox mpChBox;
  private javax.swing.JCheckBox spinChBox;
  private javax.swing.JPanel buttonsPanel;
  private javax.swing.JButton okBtn;
  private javax.swing.JButton cancelBtn;
  private javax.swing.JPanel modePanel;
  private javax.swing.JLabel modeLbl;
  private javax.swing.JRadioButton autoRBtn;
  private javax.swing.JRadioButton manualRBtn;
  // End of variables declaration//GEN-END:variables

  protected void enableEditing(boolean ttt) {
    autoRBtn.setEnabled(ttt);
    manualRBtn.setEnabled(ttt);
    browseBtn.setEnabled(ttt);
    posChBox.setEnabled(ttt);
    footprintChBox.setEnabled(ttt);
    mpChBox.setEnabled(ttt);
    spinChBox.setEnabled(ttt);
  }
  public void setFileTextField(String ss){
    this.filenameTextField.setText(ss);
  }
}