/*=========================================================================

  Program:   Orbit Visualization Tool
  Source:    $Source: /net/nest/stor/devel/ovt2g/ovt/gui/OVTTreeCellRenderer.java,v $
  Date:      $Date: 2000/04/11 15:42:06 $
  Version:   $Revision: 1.3 $


Copyright (c) 2000 OVT Team (Kristof Stasiewicz, Mykola Khotyaintsev, 
Yuri Khotyaintsev)
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification is permitted provided that the following conditions are met:

 * No part of the software can be included in any commercial package without
written consent from the OVT team.

 * Redistributions of the source or binary code must retain the above
copyright notice, this list of conditions and the following disclaimer.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT OR
INDIRECT DAMAGES  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE.

OVT Team (http://ovt.irfu.se)   K. Stasiewicz, M. Khotyaintsev, Y.
Khotyaintsev

=========================================================================*/

/*
 * OVTTreeCellRenderer.java
 *
 * Created on March 31, 2000, 12:29 PM
 */
 
package ovt.gui;

import ovt.datatype.*;
import ovt.interfaces.*;

import java.lang.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.tree.*;

/** 
 *
 * @author  ko
 * @version 
 */
public class OVTTreeCellRenderer extends DefaultTreeCellRenderer {

  public Component getTreeCellRendererComponent(JTree tree, Object value,
    boolean selected, boolean expanded, boolean leaf, int row, boolean hasFocus) 
  {
    super.getTreeCellRendererComponent(tree, value, selected, expanded, leaf, row, hasFocus);
    try {
      
      OVTNode node = (OVTNode)value;
      OVTTreeNode userObject = (OVTTreeNode)node.getUserObject();
      // set enabled
      boolean enabled = userObject.isEnabled();
      int fontType;
      if (enabled) fontType = Font.PLAIN; else fontType = Font.ITALIC;
      setFont(new Font("SansSerif", fontType, 10));
      // set icon
      Icon icon = userObject.getIcon();
      if (icon != null) setIcon(icon);
    } catch (ClassCastException e2) {
      System.out.println("class cast exception "+value.getClass().getName());
    }
    return this;
  }
  
}