/*=========================================================================

  Program:   Orbit Visualization Tool
  Source:    $Source: /net/nest/stor/devel/ovt2g/ovt/gui/PolarToolBar.java,v $
  Date:      $Date: 2000/04/11 15:42:06 $
  Version:   $Revision: 1.2 $


Copyright (c) 2000 OVT Team (Kristof Stasiewicz, Mykola Khotyaintsev, 
Yuri Khotyaintsev)
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification is permitted provided that the following conditions are met:

 * No part of the software can be included in any commercial package without
written consent from the OVT team.

 * Redistributions of the source or binary code must retain the above
copyright notice, this list of conditions and the following disclaimer.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT OR
INDIRECT DAMAGES  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE.

OVT Team (http://ovt.irfu.se)   K. Stasiewicz, M. Khotyaintsev, Y.
Khotyaintsev

=========================================================================*/

package ovt.gui;

import ovt.*;
import ovt.gui.*;
import ovt.util.*;
import ovt.beans.*;
import ovt.object.*;
import ovt.object.editor.*;
import ovt.datatype.*;


import vtk.*;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

public class PolarToolBar extends JToolBar implements ActionListener {

  protected OVTCore core;
  protected PolarWindow polarWin;
  //protected CoordSystemComboBox csComboBox;


  public PolarToolBar(OVTCore core, PolarWindow polarWin) {
    super();
    this.polarWin = polarWin;
    this.core = core;
    JPopupMenu.setDefaultLightWeightPopupEnabled(false);
    setMargin(new Insets(1, 1, 1, 1));
  
    addButtons();
    addSeparator();
    addCoordinateSystemComboBox();
    addSeparator();
    	
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
	
	//addSeparator();

	// Shirt camera controls here
	
	JButton button = new JButton("vX");
	button.setToolTipText("Veiw from X axis");
	//button.addActionListener(XYZwin.cameraPanel);
	button.setEnabled(false);
	//add(button);

	button = new JButton("vY");
	button.setToolTipText("Veiw from Y axis");
	//button.addActionListener(XYZwin.cameraPanel);
	button.setEnabled(false);
	//add(button);

	button = new JButton("vZ");
	button.setToolTipText("Veiw from Z axis");
	//button.addActionListener(XYZwin.cameraPanel);
	button.setEnabled(false);
	//add(button);
	
	//addSeparator();
	
	button = new JButton("Camera");
	button.setToolTipText("Show camera controls");
	//button.addActionListener(XYZwin.cameraPanel);
	button.setEnabled(false);
	//add(button);
	

}

  public OVTCore getCore()
	{ return core; }

  public PolarWindow getVW()
	{ return polarWin; }

  protected void addButtons() {

	JButton button = null;

	button = new JButton(new ImageIcon("images/Save.gif"));
	button.setName("Export");
	button.setToolTipText("Export image");
	button.addActionListener(this);
	button.setAlignmentY(0.5f);
        add(button);
        
        addSeparator();
        
	button = new JButton(new ImageIcon("images/Print.gif"));
	button.setName("Print");
	button.setToolTipText("Print");
	button.addActionListener(this);
        button.setAlignmentY(0.5f);
	add(button);
  }

  
  protected void addCoordinateSystemComboBox() {
    BasicPropertyDescriptor  pd = getCore().getCoordinateSystem().getDescriptors().getDescriptor("polarCoordinateSystem");
    Component comp = ((ComponentPropertyEditor)pd.getPropertyEditor()).getComponent();
    add(comp);
  }
  

public void actionPerformed(ActionEvent e) {
	
	Component  comp = (Component)e.getSource();
	String compName = comp.getName();
	if (compName.equals("Export")) ImageOperations.exportImageDialog(getVW(), getVW().getRenderWindow());
	
	if (compName.equals("Print")) ImageOperations.print(getVW(), getVW().getRenderWindow());
	
        if (compName.equals("Time")) {
          BasicPropertyDescriptor pd = getCore().getTimeSettings().getDescriptors().getDescriptor("time");
          ((WindowPropertyEditor)(pd.getPropertyEditor())).setWindowVisible(true);
        }
	
	
}

}
