/*=========================================================================

  Program:   Orbit Visualization Tool
  Source:    $Source: /net/nest/stor/devel/ovt2g/ovt/gui/XYZMenuBar.java,v $
  Date:      $Date: 2000/06/13 21:52:05 $
  Version:   $Revision: 1.9 $


Copyright (c) 2000 OVT Team (Kristof Stasiewicz, Mykola Khotyaintsev, 
Yuri Khotyaintsev)
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification is permitted provided that the following conditions are met:

 * No part of the software can be included in any commercial package without
written consent from the OVT team.

 * Redistributions of the source or binary code must retain the above
copyright notice, this list of conditions and the following disclaimer.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT OR
INDIRECT DAMAGES  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE.

OVT Team (http://ovt.irfu.se)   K. Stasiewicz, M. Khotyaintsev, Y.
Khotyaintsev

=========================================================================*/

package ovt.gui;

import ovt.*;
import ovt.mag.*;
import ovt.util.*;
import ovt.object.*;
import ovt.datatype.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import java.io.*;


public class XYZMenuBar extends JMenuBar {
    public OVTCore core;
    public XYZWindow xyzWin;
    private ovt.object.editor.SettingsEditor settingsEditor = null;

public XYZMenuBar(OVTCore core, XYZWindow xyzwin) {
  super();
  this.core = core;
  xyzWin = xyzwin;
  JMenuItem menuItem;
  JRadioButtonMenuItem rbMenuItem;
  JCheckBoxMenuItem cbMenuItem;
  String ItemName;

  Font font = new Font("Arial", Font.PLAIN, 12);


//--------------Build the File menu.-----------------

	JMenu menu = new JMenu("File");
	menu.setFont(font);
        
	menuItem = new JMenuItem("Export Image...");
        menuItem.setFont(font);
        menuItem.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent evt) {
            ImageOperations.exportImageDialog(getVW(), getVW().getRenderWindow());
          }
        });
	
        menu.add(menuItem);
        
        if ( xyzWin.windowResizable ){
          menuItem = new JMenuItem("Print...");
          menuItem.setFont(font);
          menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
              ImageOperations.print(getVW(), getVW().getRenderWindow());
            }
          });
          menu.add(menuItem);
        }

        //if ( !xyzWin.isWindowResizable() ){
          settingsEditor = new ovt.object.editor.SettingsEditor(xyzWin,true);
          menu.addSeparator();

          menuItem = new JMenuItem("Settings...");
          menuItem.setFont(font);
          menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
              settingsEditor.setVisible(true);
            }
          });

          menu.add(menuItem);
        //}
        
        menu.addSeparator();

        menuItem = new JMenuItem("Exit");
        menuItem.setFont(font);
        menuItem.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent evt) {
            getVW().quit();
          }
        });
        menu.add(menuItem);
        
        add(menu);
        // Help
        
        menu = new JMenu("Help");
        menu.setFont(font);
        
        menuItem = new JMenuItem("About");
        menuItem.setFont(font);
        menuItem.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent evt) {
            HTMLBrowser hw = getVW().getHTMLBrowser();
            String url = "file:"+getCore().getOVTHomeDir()+"docs/about.html";
            //String url = "http://www.yahoo.com";
            try {
              hw.setPage(url);
            } catch (IOException e) {e.printStackTrace();}
            hw.setVisible(true);
          }
        });
        menu.add(menuItem);
        
        menuItem = new JMenuItem("User Guide");
        menuItem.setFont(font);
        menuItem.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent evt) {
            HTMLBrowser hw = getVW().getHTMLBrowser();
            String url = "file:"+getCore().getOVTHomeDir()+"docs/userguide.html";
            //String url = "http://www.yahoo.com";
            try {
              hw.setPage(url);
            } catch (IOException e) {e.printStackTrace();}
            hw.setVisible(true);
          }
        });
        menu.add(menuItem);
        
        add(menu);

}

protected XYZWindow getVW()
	{ return xyzWin; }

protected OVTCore getCore()
	{ return getVW().getCore(); }
        
}
