/*=========================================================================

  Program:   Orbit Visualization Tool
  Source:    $Source: /net/nest/stor/devel/ovt2g/ovt/mag/MagActivityDataEditor.java,v $
  Date:      $Date: 2000/06/13 12:36:29 $
  Version:   $Revision: 1.9 $


Copyright (c) 2000 OVT Team (Kristof Stasiewicz, Mykola Khotyaintsev, 
Yuri Khotyaintsev)
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification is permitted provided that the following conditions are met:

 * No part of the software can be included in any commercial package without
written consent from the OVT team.

 * Redistributions of the source or binary code must retain the above
copyright notice, this list of conditions and the following disclaimer.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT OR
INDIRECT DAMAGES  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE.

OVT Team (http://ovt.irfu.se)   K. Stasiewicz, M. Khotyaintsev, Y.
Khotyaintsev

=========================================================================*/

/*
 * MagActivityDataEditor.java
 *
 * Created on den 25 mars 2000, 21:57
 */
 
package ovt.mag;

import javax.swing.JOptionPane;

/** 
 *
 * @author  Yuri Khotyaintsev
 * @version 1.0
 */
public class MagActivityDataEditor extends javax.swing.JFrame {
  
  MagActivityDataModel dataModel = null;

  /** Creates new form MagActivityDataEditor */
  public MagActivityDataEditor(MagActivityDataModel dataModel) {
    this.dataModel = dataModel;
    initComponents ();
    pack ();
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents () {
    //setIconImage(Toolkit.getDefaultToolkit().getImage(magProps.getCore().getImagesDir()+"ovt.gif"));
    jScrollPane1 = new javax.swing.JScrollPane ();
    Table = new javax.swing.JTable ();
    jPanel1 = new javax.swing.JPanel ();
    insertButton = new javax.swing.JButton ();
    deleteButton = new javax.swing.JButton ();
    saveButton = new javax.swing.JButton ();
    closeButton = new javax.swing.JButton ();
    setTitle ("Magnetic Activity Data Editor (OVT) :" + dataModel.getName());
    addWindowListener (new java.awt.event.WindowAdapter () {
      public void windowClosing (java.awt.event.WindowEvent evt) {
        exitForm (evt);
      }
    }
    );


    Table.setModel (dataModel);

    jScrollPane1.setViewportView (Table);


    getContentPane ().add (jScrollPane1, java.awt.BorderLayout.CENTER);

    jPanel1.setLayout (new java.awt.GridLayout (1, 4));

    insertButton.setText ("InsertRow");
    insertButton.setActionCommand ("insertButton");
    insertButton.addActionListener (new java.awt.event.ActionListener () {
      public void actionPerformed (java.awt.event.ActionEvent evt) {
        insertButtonActionPerformed (evt);
      }
    }
    );

    jPanel1.add (insertButton);

    deleteButton.setText ("Delete row");
    deleteButton.setActionCommand ("deleteButton");
    deleteButton.addActionListener (new java.awt.event.ActionListener () {
      public void actionPerformed (java.awt.event.ActionEvent evt) {
        jButton3ActionPerformed (evt);
      }
    }
    );

    jPanel1.add (deleteButton);

    saveButton.setText ("Save");
    saveButton.setActionCommand ("saveButton");
    saveButton.addActionListener (new java.awt.event.ActionListener () {
      public void actionPerformed (java.awt.event.ActionEvent evt) {
        saveButtonActionPerformed (evt);
      }
    }
    );

    jPanel1.add (saveButton);

    closeButton.setText ("Close");
    closeButton.setActionCommand ("closeButton");
    closeButton.addActionListener (new java.awt.event.ActionListener () {
      public void actionPerformed (java.awt.event.ActionEvent evt) {
        closeButtonActionPerformed (evt);
      }
    }
    );

    jPanel1.add (closeButton);
    getRootPane().setDefaultButton(closeButton);

    getContentPane ().add (jPanel1, java.awt.BorderLayout.SOUTH);

  }

private void saveButtonActionPerformed (java.awt.event.ActionEvent evt) {
  try{
    dataModel.save();
  } catch (java.io.FileNotFoundException e) {
    javax.swing.JOptionPane.showMessageDialog(this, "MagActivityDataEditor",
    "File not found", javax.swing.JOptionPane.ERROR_MESSAGE);
  } catch (java.io.IOException e){
    javax.swing.JOptionPane.showMessageDialog(this, "MagActivityDataEditor",
    "Error writing to file", javax.swing.JOptionPane.ERROR_MESSAGE); 
  }
  }

private void insertButtonActionPerformed (java.awt.event.ActionEvent evt) {
  int rw = 0;
  int row = Table.getSelectedRow();
  if ( row >= 0 ){
    int l = Table.getSelectedRowCount();
    rw = row + l - 1;
  }
  if ( ovt.OVTCore.DEBUG > 0 ) System.out.println("Inserting row after " + rw);
  dataModel.insertRows(rw);
  Table.setRowSelectionInterval(rw+1,rw+1);
  }

private void closeButtonActionPerformed (java.awt.event.ActionEvent evt) {
  setVisible(false);
  }

private void jButton3ActionPerformed (java.awt.event.ActionEvent evt) {
  int rw = 0;
  int row = Table.getSelectedRow();
  if (row >= 0){
    int l = Table.getSelectedRowCount();
    int last = row + l-1;
    if ( ovt.OVTCore.DEBUG > 0 ) System.out.println("Deleting rows " + row + "-"+last );
    dataModel.deleteRows(row, last);
  }else{
    JOptionPane.showMessageDialog(this,
                             "Nothing selected.",
                             "Error",
                             JOptionPane.ERROR_MESSAGE);
  }
  }

  /** Exit the Application */
  private void exitForm(java.awt.event.WindowEvent evt) {
    this.setVisible(false);
  }



  // Variables declaration - do not modify
  private javax.swing.JScrollPane jScrollPane1;
  private javax.swing.JTable Table;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JButton insertButton;
  private javax.swing.JButton deleteButton;
  private javax.swing.JButton saveButton;
  private javax.swing.JButton closeButton;
  // End of variables declaration

}
