/*=========================================================================

  Program:   Orbit Visualization Tool
  Source:    $Source: /net/nest/stor/devel/ovt2g/ovt/mag/MagPropsEditor.java,v $
  Date:      $Date: 2000/06/13 12:19:57 $
  Version:   $Revision: 1.9 $


Copyright (c) 2000 OVT Team (Kristof Stasiewicz, Mykola Khotyaintsev, 
Yuri Khotyaintsev)
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification is permitted provided that the following conditions are met:

 * No part of the software can be included in any commercial package without
written consent from the OVT team.

 * Redistributions of the source or binary code must retain the above
copyright notice, this list of conditions and the following disclaimer.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT OR
INDIRECT DAMAGES  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE.

OVT Team (http://ovt.irfu.se)   K. Stasiewicz, M. Khotyaintsev, Y.
Khotyaintsev

=========================================================================*/

/*
 * MagPropsEditor.java
 *
 * Created on den 3 april 2000, 16:06
 */

package ovt.mag;

/**
 *
 * @author  yuri
 * @version
 */
public class MagPropsEditor extends javax.swing.JFrame {

  /** Creates new form MagPropsEditor */
  public MagPropsEditor(MagProps magProps) {
    this.magProps = magProps;
    internalGroup = new javax.swing.ButtonGroup();
    externalGroup = new javax.swing.ButtonGroup();
    initComponents ();
    pack ();
  }

  private MagProps magProps = null;
  private javax.swing.ButtonGroup internalGroup;
  private javax.swing.ButtonGroup externalGroup;

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents () {
    setIconImage(java.awt.Toolkit.getDefaultToolkit().getImage(magProps.getCore().getImagesDir()+"ovt.gif"));
    activityPanel = new javax.swing.JPanel ();
    kpindexLabel = new javax.swing.JLabel ();
    kpindexEditBtn = new javax.swing.JButton ();
    imfLabel = new javax.swing.JLabel ();
    imfEditBtn = new javax.swing.JButton ();
    swpLabel = new javax.swing.JLabel ();
    swpEditBtn = new javax.swing.JButton ();
    dstindexLabel = new javax.swing.JLabel ();
    dstindexEditBtn = new javax.swing.JButton ();
    buttonPanel = new javax.swing.JPanel ();
    OKBtn = new javax.swing.JButton ();
    cancelBtn = new javax.swing.JButton ();
    applyBtn = new javax.swing.JButton ();
    modelsPanel = new javax.swing.JPanel ();
    internalPanel = new javax.swing.JPanel ();
    igrfRButton = new javax.swing.JRadioButton ();
    dipoleRButton = new javax.swing.JRadioButton ();
    externalPanel = new javax.swing.JPanel ();
    t87RButton = new javax.swing.JRadioButton ();
    t89RButton = new javax.swing.JRadioButton ();
    t96RButton = new javax.swing.JRadioButton ();
    setTitle ("MagProps Editor");
    addWindowListener (new java.awt.event.WindowAdapter () {
      public void windowClosing (java.awt.event.WindowEvent evt) {
        exitForm (evt);
      }
    }
    );

    activityPanel.setLayout (new java.awt.GridLayout (4, 2));
    activityPanel.setBorder (new javax.swing.border.TitledBorder(
    new javax.swing.border.EtchedBorder(java.awt.Color.white, new java.awt.Color (134, 134, 134)),
    "Activity", 1, 2, new java.awt.Font ("Dialog", 0, 11), java.awt.Color.black));
    activityPanel.setName ("Activity");

      kpindexLabel.setAlignmentX (10.0F);
      kpindexLabel.setText (ovt.mag.MagProps.KPINDEX);
      kpindexLabel.setHorizontalAlignment (javax.swing.SwingConstants.LEFT);
  
      activityPanel.add (kpindexLabel);
  
      kpindexEditBtn.setPreferredSize (kpindexEditBtn.getMinimumSize ());
      kpindexEditBtn.setMaximumSize (kpindexEditBtn.getPreferredSize ());
      kpindexEditBtn.setText ("Edit ...");
      kpindexEditBtn.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          kpindexEditBtnActionPerformed (evt);
        }
      }
      );
  
      activityPanel.add (kpindexEditBtn);
  
      imfLabel.setText (ovt.mag.MagProps.IMF);
      imfLabel.setHorizontalAlignment (javax.swing.SwingConstants.LEFT);
  
      activityPanel.add (imfLabel);
  
      imfEditBtn.setText ("Edit ...");
      imfEditBtn.setEnabled (false);
      imfEditBtn.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          imfEditBtnActionPerformed (evt);
        }
      }
      );
  
      activityPanel.add (imfEditBtn);
  
      swpLabel.setText (ovt.mag.MagProps.SWP);
      swpLabel.setHorizontalAlignment (javax.swing.SwingConstants.LEFT);
  
      activityPanel.add (swpLabel);
  
      swpEditBtn.setText ("Edit ...");
      swpEditBtn.setEnabled (false);
      swpEditBtn.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          swpEditBtnActionPerformed (evt);
        }
      }
      );
  
      activityPanel.add (swpEditBtn);
  
      dstindexLabel.setText (ovt.mag.MagProps.DSTINDEX);
      dstindexLabel.setHorizontalAlignment (javax.swing.SwingConstants.LEFT);
  
      activityPanel.add (dstindexLabel);
  
      dstindexEditBtn.setText ("Edit ...");
      dstindexEditBtn.setEnabled (false);
      dstindexEditBtn.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          dstindexEditBtnActionPerformed (evt);
        }
      }
      );
  
      activityPanel.add (dstindexEditBtn);
  
  
    getContentPane ().add (activityPanel, java.awt.BorderLayout.CENTER);

    buttonPanel.setLayout (new java.awt.GridLayout (1, 3));

      OKBtn.setText ("OK");
      getRootPane().setDefaultButton(OKBtn);
      OKBtn.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          OKBtnActionPerformed (evt);
        }
      }
      );
  
      buttonPanel.add (OKBtn);
  
      cancelBtn.setText ("Cancel");
      cancelBtn.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          cancelBtnActionPerformed (evt);
        }
      }
      );
  
      buttonPanel.add (cancelBtn);
  
      applyBtn.setText ("Apply");
      applyBtn.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          applyBtnActionPerformed (evt);
        }
      }
      );
  
      buttonPanel.add (applyBtn);
  

    getContentPane ().add (buttonPanel, java.awt.BorderLayout.SOUTH);

    modelsPanel.setLayout (new java.awt.GridLayout (1, 2));

      internalPanel.setLayout (new java.awt.GridLayout (2, 1));
      internalPanel.setBorder (new javax.swing.border.TitledBorder(
      new javax.swing.border.EtchedBorder(java.awt.Color.white, new java.awt.Color (134, 134, 134)),
      "Internal Models", 1, 2, new java.awt.Font ("Dialog", 0, 11), java.awt.Color.black));
      internalPanel.setName ("Intermal models");
  
        igrfRButton.setSelected (magProps.getInternalModelType()== MagProps.IGRF);
        igrfRButton.setText ("IGRF");
        internalGroup.add(igrfRButton);
    
        internalPanel.add (igrfRButton);
    
        dipoleRButton.setSelected (magProps.getInternalModelType()== MagProps.DIPOLE);
        dipoleRButton.setText ("Dipole");
        internalGroup.add(dipoleRButton);
    
        internalPanel.add (dipoleRButton);
    
      modelsPanel.add (internalPanel);
  
      externalPanel.setLayout (new java.awt.GridLayout (3, 1));
      externalPanel.setBorder (new javax.swing.border.TitledBorder(
      new javax.swing.border.EtchedBorder(java.awt.Color.white, new java.awt.Color (134, 134, 134)),
      "External models", 3, 2, new java.awt.Font ("Dialog", 0, 11), java.awt.Color.black));
  
        t87RButton.setSelected (magProps.getExternalModelType()== MagProps.T87);
        t87RButton.setText ("Tsyganenko 87");
        externalGroup.add(t87RButton);
        t87RButton.addChangeListener (new javax.swing.event.ChangeListener () {
          public void stateChanged (javax.swing.event.ChangeEvent evt) {
            t87RButtonStateChanged (evt);
          }
        }
        );
    
        externalPanel.add (t87RButton);
    
        t89RButton.setSelected (magProps.getExternalModelType()== MagProps.T89);
        t89RButton.setText ("Tsyganenko 89");
        externalGroup.add(t89RButton);
        t89RButton.addChangeListener (new javax.swing.event.ChangeListener () {
          public void stateChanged (javax.swing.event.ChangeEvent evt) {
            t89RButtonStateChanged (evt);
          }
        }
        );
    
        externalPanel.add (t89RButton);
    
        t96RButton.setSelected (magProps.getExternalModelType()== MagProps.T96);
        t96RButton.setText ("Tsyganenko 96");
        externalGroup.add(t96RButton);
        t96RButton.addChangeListener (new javax.swing.event.ChangeListener () {
          public void stateChanged (javax.swing.event.ChangeEvent evt) {
            t96RButtonStateChanged (evt);
          }
        }
        );
    
        externalPanel.add (t96RButton);
    
      modelsPanel.add (externalPanel);
  

    getContentPane ().add (modelsPanel, java.awt.BorderLayout.NORTH);

  }

  private void doCancel() {
    this.setVisible(false);
    igrfRButton.setSelected (magProps.getInternalModelType()== MagProps.IGRF);
    dipoleRButton.setSelected (magProps.getInternalModelType()== MagProps.DIPOLE);
    t87RButton.setSelected (magProps.getExternalModelType()== MagProps.T87);
    t89RButton.setSelected (magProps.getExternalModelType()== MagProps.T89);
    t96RButton.setSelected (magProps.getExternalModelType()== MagProps.T96);
  }

  private void cancelBtnActionPerformed (java.awt.event.ActionEvent evt) {
    doCancel();
  }

  private void OKBtnActionPerformed (java.awt.event.ActionEvent evt) {
    this.setVisible(false);
    applyBtnActionPerformed(evt);
  }

  private void applyBtnActionPerformed (java.awt.event.ActionEvent evt) {
    int intModel, extModel;

    if ( igrfRButton.isSelected() ) intModel = MagProps.IGRF;
    else intModel = MagProps.DIPOLE;

    if ( t87RButton.isSelected() ) extModel = MagProps.T87;
    else if ( t89RButton.isSelected() )  extModel = MagProps.T89;
    else extModel = MagProps.T96;

    try {
      magProps.setModelTypes(new ModelTypes(intModel, extModel));
      magProps.getCore().Render();
    } catch (java.beans.PropertyVetoException e){
      System.out.println("Something is wrong with my head ...");
    }

  }

  private void dstindexEditBtnActionPerformed (java.awt.event.ActionEvent evt) {
    java.awt.Point pp = this.getLocation();
    magProps.dstindexEditor.setLocation(pp.x + 10, pp.y + 10);
    magProps.dstindexEditor.setVisible(true);
  }

  private void swpEditBtnActionPerformed (java.awt.event.ActionEvent evt) {
    java.awt.Point pp = this.getLocation();
    magProps.swpEditor.setLocation(pp.x + 10, pp.y + 10);
    magProps.swpEditor.setVisible(true);
  }

  private void imfEditBtnActionPerformed (java.awt.event.ActionEvent evt) {
    java.awt.Point pp = this.getLocation();
    magProps.imfEditor.setLocation(pp.x + 10, pp.y + 10);
    magProps.imfEditor.setVisible(true);
  }

  private void kpindexEditBtnActionPerformed (java.awt.event.ActionEvent evt) {
    java.awt.Point pp = this.getLocation();
    magProps.kpindexEditor.setLocation(pp.x + 10, pp.y + 10);
    magProps.kpindexEditor.setVisible(true);
  }

  private void t96RButtonStateChanged (javax.swing.event.ChangeEvent evt) {
    imfEditBtn.setEnabled (t96RButton.isSelected());
    swpEditBtn.setEnabled (t96RButton.isSelected());
    dstindexEditBtn.setEnabled (t96RButton.isSelected());
  }

  private void t89RButtonStateChanged (javax.swing.event.ChangeEvent evt) {
    kpindexEditBtn.setEnabled (t89RButton.isSelected());
  }

  private void t87RButtonStateChanged (javax.swing.event.ChangeEvent evt) {
    kpindexEditBtn.setEnabled ( t87RButton.isSelected() );
  }

  /** Exit the Application */
  private void exitForm(java.awt.event.WindowEvent evt) {
    doCancel();
  }



  // Variables declaration - do not modify
  private javax.swing.JPanel activityPanel;
  private javax.swing.JLabel kpindexLabel;
  private javax.swing.JButton kpindexEditBtn;
  private javax.swing.JLabel imfLabel;
  private javax.swing.JButton imfEditBtn;
  private javax.swing.JLabel swpLabel;
  private javax.swing.JButton swpEditBtn;
  private javax.swing.JLabel dstindexLabel;
  private javax.swing.JButton dstindexEditBtn;
  private javax.swing.JPanel buttonPanel;
  private javax.swing.JButton OKBtn;
  private javax.swing.JButton cancelBtn;
  private javax.swing.JButton applyBtn;
  private javax.swing.JPanel modelsPanel;
  private javax.swing.JPanel internalPanel;
  private javax.swing.JRadioButton igrfRButton;
  private javax.swing.JRadioButton dipoleRButton;
  private javax.swing.JPanel externalPanel;
  private javax.swing.JRadioButton t87RButton;
  private javax.swing.JRadioButton t89RButton;
  private javax.swing.JRadioButton t96RButton;
  // End of variables declaration

}
