/*=========================================================================

  Program:   Orbit Visualization Tool
  Source:    $Source: /net/nest/stor/devel/ovt2g/ovt/object/Frames.java,v $
  Date:      $Date: 2000/04/11 15:42:26 $
  Version:   $Revision: 1.5 $


Copyright (c) 2000 OVT Team (Kristof Stasiewicz, Mykola Khotyaintsev, 
Yuri Khotyaintsev)
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification is permitted provided that the following conditions are met:

 * No part of the software can be included in any commercial package without
written consent from the OVT team.

 * Redistributions of the source or binary code must retain the above
copyright notice, this list of conditions and the following disclaimer.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT OR
INDIRECT DAMAGES  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE.

OVT Team (http://ovt.irfu.se)   K. Stasiewicz, M. Khotyaintsev, Y.
Khotyaintsev

=========================================================================*/

package ovt.object;

import ovt.*;
import ovt.mag.*;
import ovt.event.*;
import ovt.beans.*;
import ovt.datatype.*;
import ovt.interfaces.*;

import vtk.*;

import java.beans.*;
import java.util.*;

public class Frames extends VisualObject
				 implements TimeChangeListener {

  
  vtkActor YOZActor = null, XOZActor = null, XOYActor = null;
  
  boolean isInitialised = false;
	
  public Frames(OVTCore core) { 
    super(core, "Frames", OVTCore.getImagesDir() + "frame.gif");
    Children hippies = new Children();
    FrameModule funky = new FrameModule(this, FrameModule.XOYPLANE);
    hippies.put(funky );
    funky = new FrameModule(this, FrameModule.XOZPLANE);
    hippies.put(funky );
    funky = new FrameModule(this, FrameModule.YOZPLANE);
    hippies.put(funky );
    setChildren(hippies);
  }

  public void setVisible(boolean visible) {
    if (visible != isVisible()) {
      Enumeration e = getChildren().elements();
      while (e.hasMoreElements())
        ((FrameModule)e.nextElement()).setVisible(visible);
      super.setVisible(visible);
    }
  }
  
public void timeChanged(TimeEvent e) {}


}	
