/*=========================================================================

  Program:   Orbit Visualization Tool
  Source:    $Source: /net/nest/stor/devel/ovt2g/ovt/object/Settings.java,v $
  Date:      $Date: 2000/06/11 15:45:10 $
  Version:   $Revision: 1.5 $


Copyright (c) 2000 OVT Team (Kristof Stasiewicz, Mykola Khotyaintsev, 
Yuri Khotyaintsev)
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification is permitted provided that the following conditions are met:

 * No part of the software can be included in any commercial package without
written consent from the OVT team.

 * Redistributions of the source or binary code must retain the above
copyright notice, this list of conditions and the following disclaimer.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT OR
INDIRECT DAMAGES  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE.

OVT Team (http://ovt.irfu.se)   K. Stasiewicz, M. Khotyaintsev, Y.
Khotyaintsev

=========================================================================*/
/*
 * Settings.java
 *
 * Created on den 9 juni 2000, 13:39
 */
 
package ovt.object;

import java.io.*;

/** 
 *
 * @author  yuri
 * @version 
 */
public class Settings extends java.util.Properties {

  private File settingsFile = null;
  /** Creates new Settings */
  public Settings(String settingsFileName) {
    super();
    // Defaults
    put("XYZWindow.size.x","400");
    put("XYZWindow.size.y","400");
    
    settingsFile = new File(settingsFileName);
    try {
      FileInputStream inStream = new FileInputStream(settingsFile);
      load(inStream);
    } catch(FileNotFoundException e) {
      System.out.println("File not found: "+settingsFileName);
    } catch(IOException e) {
      System.out.println("IO error while reading: "+settingsFileName);
    }
  }
  public void store() throws FileNotFoundException, IOException {
    FileOutputStream outStream = new FileOutputStream(settingsFile);
    save(outStream,"OVT Settings");
  }
}