/*=========================================================================

  Program:   Orbit Visualization Tool
  Source:    $Source: /net/nest/stor/devel/ovt2g/ovt/object/editor/MagnetopausePropertyEditor.java,v $
  Date:      $Date: 2000/06/09 13:22:50 $
  Version:   $Revision: 1.3 $


Copyright (c) 2000 OVT Team (Kristof Stasiewicz, Mykola Khotyaintsev, 
Yuri Khotyaintsev)
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification is permitted provided that the following conditions are met:

 * No part of the software can be included in any commercial package without
written consent from the OVT team.

 * Redistributions of the source or binary code must retain the above
copyright notice, this list of conditions and the following disclaimer.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT OR
INDIRECT DAMAGES  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE.

OVT Team (http://ovt.irfu.se)   K. Stasiewicz, M. Khotyaintsev, Y.
Khotyaintsev

=========================================================================*/

/*
 * MagnetopausePropertyEditor.java
 *
 * Created on April 11, 2000, 7:30 PM
 */
 
package ovt.object.editor;

import ovt.mag.*;

import java.awt.Toolkit;

/** 
 *
 * @author  Yuri Khotyaintsev
 * @version 
 */
public class MagnetopausePropertyEditor extends javax.swing.JFrame {

  /** Creates new form BowShockPropertyEditor */
  public MagnetopausePropertyEditor(MagProps magProps) {
    this.magProps = magProps;
    initComponents ();
    pack ();
  }
  
  private MagProps magProps = null;

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents () {//GEN-BEGIN:initComponents
    activityPanel = new javax.swing.JPanel ();
    swpLbl = new javax.swing.JLabel ();
    swpBtn = new javax.swing.JButton ();
    imfLbl = new javax.swing.JLabel ();
    imfBtn = new javax.swing.JButton ();
    clipLbl = new javax.swing.JLabel ();
    clipChbox = new javax.swing.JCheckBox ();
    buttonsPanel = new javax.swing.JPanel ();
    OKBtn = new javax.swing.JButton ();
    cancelBtn = new javax.swing.JButton ();
    applyBtn = new javax.swing.JButton ();
    setIconImage (Toolkit.getDefaultToolkit().getImage(magProps.getCore().getImagesDir()+"ovt.gif"));
    setTitle ("Magnetopause Property Editor");
    addWindowListener (new java.awt.event.WindowAdapter () {
      public void windowClosing (java.awt.event.WindowEvent evt) {
        exitForm (evt);
      }
    }
    );

    activityPanel.setLayout (new java.awt.GridLayout (3, 2));
    activityPanel.setBorder (new javax.swing.border.TitledBorder("Activity"));

      swpLbl.setText (ovt.mag.MagProps.SWP);
  
      activityPanel.add (swpLbl);
  
      swpBtn.setText ("Edit ...");
      swpBtn.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          jButton5ActionPerformed (evt);
        }
      }
      );
  
      activityPanel.add (swpBtn);
  
      imfLbl.setText (ovt.mag.MagProps.IMF);
  
      activityPanel.add (imfLbl);
  
      imfBtn.setText ("Edit ...");
      imfBtn.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          machnumberBtnActionPerformed (evt);
        }
      }
      );
  
      activityPanel.add (imfBtn);
  
      clipLbl.setText (ovt.mag.MagProps.MPCLIP);
      clipLbl.setHorizontalAlignment (javax.swing.SwingConstants.LEFT);
  
      activityPanel.add (clipLbl);
  
      clipChbox.setHorizontalTextPosition (javax.swing.SwingConstants.RIGHT);
      clipChbox.setSelected (true);
      clipChbox.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          clipChboxActionPerformed (evt);
        }
      }
      );
  
      activityPanel.add (clipChbox);
  

    getContentPane ().add (activityPanel, java.awt.BorderLayout.CENTER);

    buttonsPanel.setLayout (new java.awt.GridLayout (1, 3));

      OKBtn.setText ("OK");
      getRootPane().setDefaultButton(OKBtn);
      OKBtn.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          OKBtnActionPerformed (evt);
        }
      }
      );
  
      buttonsPanel.add (OKBtn);
  
      cancelBtn.setText ("Cancel");
      cancelBtn.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          cancelBtnActionPerformed (evt);
        }
      }
      );
  
      buttonsPanel.add (cancelBtn);
  
      applyBtn.setText ("Apply");
      applyBtn.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          applyBtnActionPerformed (evt);
        }
      }
      );
  
      buttonsPanel.add (applyBtn);
  

    getContentPane ().add (buttonsPanel, java.awt.BorderLayout.SOUTH);

  }//GEN-END:initComponents

  private void clipChboxActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clipChboxActionPerformed
    // Add your handling code here:
    ovt.mag.MagProps.setMPClipping(clipChbox.isSelected());
    //System.out.println(ovt.mag.MagProps.isMPClipping()); //checking
  }//GEN-LAST:event_clipChboxActionPerformed

  private void applyBtnActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_applyBtnActionPerformed
    // Add your handling code here:
    magProps.fireMagPropsChange();
    magProps.getCore().Render();
  }//GEN-LAST:event_applyBtnActionPerformed

  private void OKBtnActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_OKBtnActionPerformed
    this.setVisible(false);
    applyBtnActionPerformed(evt);
  }//GEN-LAST:event_OKBtnActionPerformed

  private void machnumberBtnActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_machnumberBtnActionPerformed
    java.awt.Point pp = this.getLocation();
    magProps.imfEditor.setLocation(pp.x + 10, pp.y + 10);
    magProps.imfEditor.setVisible(true);
  }//GEN-LAST:event_machnumberBtnActionPerformed

  private void jButton5ActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
    java.awt.Point pp = this.getLocation();
    magProps.swpEditor.setLocation(pp.x + 10, pp.y + 10);
    magProps.swpEditor.setVisible(true);
  }//GEN-LAST:event_jButton5ActionPerformed

  private void cancelBtnActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelBtnActionPerformed
    doCancel();
  }//GEN-LAST:event_cancelBtnActionPerformed

  /** Exit the Application */
  private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
    doCancel();
  }//GEN-LAST:event_exitForm



  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JPanel activityPanel;
  private javax.swing.JLabel swpLbl;
  private javax.swing.JButton swpBtn;
  private javax.swing.JLabel imfLbl;
  private javax.swing.JButton imfBtn;
  private javax.swing.JLabel clipLbl;
  private javax.swing.JCheckBox clipChbox;
  private javax.swing.JPanel buttonsPanel;
  private javax.swing.JButton OKBtn;
  private javax.swing.JButton cancelBtn;
  private javax.swing.JButton applyBtn;
  // End of variables declaration//GEN-END:variables

  public void doCancel() {
    this.setVisible(false);
  }
}