/*=========================================================================

  Program:   Orbit Visualization Tool
  Source:    $Source: /net/nest/stor/devel/ovt2g/ovt/object/editor/TimeEditor.java,v $
  Date:      $Date: 2000/04/11 15:42:29 $
  Version:   $Revision: 1.3 $


Copyright (c) 2000 OVT Team (Kristof Stasiewicz, Mykola Khotyaintsev, 
Yuri Khotyaintsev)
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification is permitted provided that the following conditions are met:

 * No part of the software can be included in any commercial package without
written consent from the OVT team.

 * Redistributions of the source or binary code must retain the above
copyright notice, this list of conditions and the following disclaimer.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT OR
INDIRECT DAMAGES  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE.

OVT Team (http://ovt.irfu.se)   K. Stasiewicz, M. Khotyaintsev, Y.
Khotyaintsev

=========================================================================*/

/*
 * TimeEditor.java
 *
 * Created on March 2, 2000, 7:40 PM
 */
 
package ovt.object.editor;

import ovt.util.*;
import ovt.beans.*;
import ovt.datatype.*;
import ovt.interfaces.*;

import java.beans.*;
import javax.swing.*;
import java.awt.*;

/** 
 *
 * @author  root
 * @version 
 */
public class TimeEditor extends WindowPropertyEditor {

  protected Component comp;
  
  /** Creates new TimeEditor */
  public TimeEditor(BasicPropertyDescriptor pd) {
    super(pd, MenuPropertyEditor.SWITCH);
  }
  
  public void setTime(TimeSet time) throws PropertyVetoException {
    Object[] beans = Vect.toArray(getBeans());
    for (int i=0; i<beans.length; i++) 
      setValue(time.clone(), beans[0]);
  }
   
  public Component getComponent() {
    if (comp == null) {
      comp = new TimeEditorPanel(this);
      addPropertyChangeListener((PropertyChangeListener)comp);
    }
    return comp;
  }
}