/*=========================================================================

  Program:   Orbit Visualization Tool
  Source:    $Source: /net/nest/stor/devel/ovt2g/ovt/util/ImageOperations.java,v $
  Date:      $Date: 2000/06/13 21:45:48 $
  Version:   $Revision: 1.4 $


Copyright (c) 2000 OVT Team (Kristof Stasiewicz, Mykola Khotyaintsev, 
Yuri Khotyaintsev)
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification is permitted provided that the following conditions are met:

 * No part of the software can be included in any commercial package without
written consent from the OVT team.

 * Redistributions of the source or binary code must retain the above
copyright notice, this list of conditions and the following disclaimer.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT OR
INDIRECT DAMAGES  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE.

OVT Team (http://ovt.irfu.se)   K. Stasiewicz, M. Khotyaintsev, Y.
Khotyaintsev

=========================================================================*/

/*
 * ImageOperations.java
 *
 * Created on March 21, 2000, 7:04 PM
 */
 
package ovt.util;


import vtk.*;

import javax.swing.*;
import java.io.*;
import java.lang.*;

/** 
 *
 * @author  root
 * @version 
 */
public class ImageOperations extends Object {

  /** Creates new ImageOperations */
  public ImageOperations() {
  }
  
  public static void exportImage(vtkRenderWindow renderWindow, String filename, String type) {
    vtkImageWriter writer;
		
	if (type.equals("BMP"))
		writer = new vtkBMPWriter();
		
	else if (type.equals("TIFF"))
		writer = new vtkTIFFWriter();
		
	else if (type.equals("PNM"))
		writer = new vtkPNMWriter();
		
	else throw new IllegalArgumentException("The grafics file format not supported"); // No known formats were selected.

	//toFront(); // Places this window at the top of the stacking order and 
				   //shows it in front of any other windows.

	vtkWindowToImageFilter windowToImageFilter = new vtkWindowToImageFilter();
	windowToImageFilter.SetInput(renderWindow);
		
	writer.SetInput(windowToImageFilter.GetOutput());
	writer.SetFileName(filename);
	writer.Write();

  }
  
  public static void exportImageDialog(JFrame frameOwner, vtkRenderWindow renderWindow) {

	JFileChooser chooser = new JFileChooser(); 
	chooser.setDialogTitle("Export window to Image");
	OvtExtensionFileFilter filter = new OvtExtensionFileFilter(); 
	filter.addExtension("bmp"); 
	filter.setDescription("BMP"); 
	chooser.setFileFilter(filter);
	
	filter = new OvtExtensionFileFilter(); 
	filter.addExtension("tiff");
	filter.addExtension("tif");
	filter.setDescription("TIFF"); 
	chooser.addChoosableFileFilter(filter);
	
	filter = new OvtExtensionFileFilter(); 
	filter.addExtension("pnm"); 
	filter.setDescription("PNM"); 
        //chooser.setLocation(frameOwner.getLocation().x+frameOwner.getSize().width,frameOwner.getLocation().y);
	chooser.addChoosableFileFilter(filter);
	
	frameOwner.toFront(); // Places this window at the top of the stacking order and 
				   //shows it in front of any other windows.

	
	int returnVal = chooser.showSaveDialog(frameOwner);
	
	if(returnVal == JFileChooser.APPROVE_OPTION) {
		System.out.println("You chose to open this file:" + chooser.getSelectedFile().getName()); 
		exportImage(renderWindow, chooser.getSelectedFile().getPath(), chooser.getFileFilter().getDescription());
	} 
  }
  
  public static void print(JFrame frameOwner, vtkRenderWindow renderWindow) {
	try {
		PrintVTKWindow.PrintVTKWindow(frameOwner, renderWindow);
	} catch (IOException e) {
		System.out.println("I/O error occured while printing.\n"+e.toString());
	}
}

}