/*=========================================================================

  Program:   Orbit Visualization Tool
  Source:    $Source: /net/nest/stor/devel/ovt2g/ovt/util/PrintVTKWindow.java,v $
  Date:      $Date: 2000/06/13 20:59:02 $
  Version:   $Revision: 1.5 $


Copyright (c) 2000 OVT Team (Kristof Stasiewicz, Mykola Khotyaintsev, 
Yuri Khotyaintsev)
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification is permitted provided that the following conditions are met:

 * No part of the software can be included in any commercial package without
written consent from the OVT team.

 * Redistributions of the source or binary code must retain the above
copyright notice, this list of conditions and the following disclaimer.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT OR
INDIRECT DAMAGES  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE.

OVT Team (http://ovt.irfu.se)   K. Stasiewicz, M. Khotyaintsev, Y.
Khotyaintsev

=========================================================================*/

package ovt.util;

import ovt.graphics.*;

import vtk.*;

import java.awt.*;
import java.io.IOException;
import java.io.File;
import java.util.Properties;

public class PrintVTKWindow {



public static void PrintVTKWindow(Frame window, vtkRenderWindow renderWindow) 
	throws IOException {

	// to be corrected.
        
        String tmpDir = System.getProperty("java.io.tmpdir");
        if ( tmpDir == null ) tmpDir = ovt.OVTCore.getUserdataDir();
	String tempFile = tmpDir + "XYZWindow.bmp";
	
	Toolkit tk = Toolkit.getDefaultToolkit();
	
	if (tk != null) {
	
		PrintJob printJob =  tk.getPrintJob(window, window.getTitle(), (Properties)null);
		
		if (printJob != null) {
		
			Graphics pg = printJob.getGraphics();
			
			if (pg != null) {
			
				// Write to temprorary file image
				window.toFront();
				
				vtkBMPWriter writer = new vtkBMPWriter();
				vtkWindowToImageFilter windowToImageFilter = new vtkWindowToImageFilter();
				windowToImageFilter.SetInput(renderWindow);
		
				writer.SetInput(windowToImageFilter.GetOutput());
				writer.SetFileName(tempFile);
				
				//  path an exception up
				//try {
					writer.Write();
				//} catch (IOException e) System.out.println(e.toString);
				
				
				
				//int width = getSize().width;
				//int height = getSize().height;
				
				
				// Create a window and print it
				BMPWindow tpw = new BMPWindow(tempFile);
				tpw.setTitle("Print Preview");
				tpw.setLocation(500,500);
				//tpw.show();
				
				tpw.print(pg);
				
				pg.dispose();
				
				tpw.dispose();
				
				// delete temprorary file
				new File(tempFile).delete();
			}
			
			printJob.end();
			
		}
			
	}
	
}



}

